{% extends 'base.html' %}
{% block title %} Create Archive {% endblock %}
{% block content %}
    <form class="form-control" id="archive_create_form" method="post" enctype="multipart/form-data">
        {% csrf_token %}
        <div class="row row-eq-height row-col-2">
            <div class="row">
                <div class="col col-md-6 " id="archive_create_form">

                    {{ archive_create_form.as_p }}
                    <label for='dt_create'> Add Template (OCR) &nbsp;</label><input type='radio' name='box1'
                                                                                    id='dt_create'>
                    <br>
                    <label for='fields_create'> Add Fields (no OCR) &nbsp;</label><input type='radio' name='box2'
                                                                                         id='fields_create'>
                    <br>
                </div>
                <div class="col col-md-6 " id="collection_create_form">
                    {{ collection_form.as_p }}
                </div>
                <div class="col col-md-6 " id="dt_create_form" style="display: none">
                    {{ document_template_form.as_p }}
                </div>
            </div>
            <div class="row">
                <div class="col-6" id="roi_create_form" style="display: none">
                    {{ roi_form.as_p }}
                    <img id="roi_img" src="" alt="" style="height: 600px; width: 600px;">
                </div>
                <div class="col">
                    <div class="input_roi_wrap" id="input_roi" style="display: none">
                        <button class="add_roi_button btn btn-sm btn-primary mt-5">Add ROI</button>
                        <br>
                        <button id="roi_0" value="0" style="display: none"></button>

                    </div>
                </div>
            </div>
            <div class="col-6" id="fields_create_form" style="display: none">
                <div class="input_fields_wrap" id="input_fields">
                    <button class="add_field_button btn btn-sm btn-primary  ">Add More Fields</button>
                    <br>

                    <div><label for="field_1"></label><input class="fields" type="text" id="field_1"></div>
                </div>
            </div>
        </div>
        <br>
        <button type="submit" class="btn btn-primary btn-sm">Submit</button>

    </form>


    <script>
        {#$('#archive_create_form').submit(function () {#}
        {#    var types = [];#}
        {#    if ($("input[name='box1']").is(':checked')) {#}
        {#        $("input[name='ocr']").each(function () {#}
        {#            types.push($(this).val());#}
        {#        });#}
        {#        var ocrpoints = '{[' + types + ']}';#}
        {#        $('#id_region_points').val(ocrpoints);#}
        {#    } else {#}
        {#        $("input[name='no_ocr']").each(function () {#}
        {#            types.push($(this).val());#}
        {#        });#}
        {#        var rpoints = '{no-ocr:' + types + '}';#}
        {#        $('#id_region_points').val(rpoints);#}
        {#    }#}
        {#    return true;#}
        //});



        $(document).ready(function () {
            var max_fields = 10; //maximum input boxes allowed
            var wrapper = $(".input_fields_wrap"); //Fields wrapper
            var add_button = $(".add_field_button"); //Add button ID
            var x = 1; //initlal text box count
            $(add_button).click(function (e) { //on add input button click
                e.preventDefault();
                const field_name = 'field_' + x.toString()
                if ($('#' + field_name).val().length > 0) {
                    if (x < max_fields) { //max input box allowed
                        x++; //text box increment
                        const field_name = 'field_' + x.toString()
                        $(wrapper).append('<br><div><input class="fields" type="text" id="' + field_name + '" name="no_ocr" /><a href="#" class="remove_field bi bi-dash-circle"></a></div>'); //add input box
                    } else {
                        alert("Max fields reached")
                    }
                } else {
                    alert("add field name")
                }
            });

            $(wrapper).on("click", ".remove_field", function (e) { //user click on remove text
                e.preventDefault();
                $(this).parent('div').remove();
                x--;
            })
        });

        $(function () {
            $('#dt_create').click(function () {
                if ($('#dt_create').is(':checked')) {
                    $('#dt_create_form').show();
                    $('#fields_create').prop("checked", false);
                    $('#fields_create_form').hide();
                }
            });
            $('#fields_create').click(function () {
                if ($('#fields_create').is(':checked')) {
                    $('#dt_name').val('No-Name')
                    $('#id_roi_name').val('No-Name')
                    $('#fields_create_form').show();
                    $('#dt_create').prop("checked", false);
                    $('#dt_create_form').hide();
                }
            });

            $('#template_file').change(function () {
                if (this.files && this.files[0]) {
                    console.log(this.files)
                    var reader = new FileReader();
                    reader.onload = function (e) {
                        $('#roi_img').replaceWith('<img id="roi_img" class="img-fluid" src="' + e.target.result + '" alt=""/>')
                        var img = document.getElementById("roi_img");
                        var imgscale = img.naturalHeight / img.height
                        console.log(img.height, img.width);
                        console.log(img.naturalHeight, img.naturalWidth);
                        console.log(imgscale);
                        window.imgscale = imgscale
                    }
                    reader.readAsDataURL(this.files[0]);
                    $('#roi_create_form').show();
                    $('#input_roi').show();
                }

            });
        });
        var jcrop_api;
        $(document).ready(function () {

            var max_roi = 10; //maximum input boxes allowed
            var wrapper = $(".input_roi_wrap"); //Fields wrapper
            var add_roi_button = $(".add_roi_button"); //Add button ID
            var rx = 0; //initlal text box count
            $(add_roi_button).click(function (e) { //on add input button click
                e.preventDefault();
                const roi_name = 'roi_' + rx.toString()
                if ($('#' + roi_name).val().length > 0) {
                    if (rx < max_roi) { //max input box allowed
                        rx++; //text box increment
                        const roi_name = 'roi_' + rx.toString()
                        $(wrapper).append('<br>' +
                            '<div class="inline-labels">' +
                            '<div><input class="form-control-sm" type="text" id="' + roi_name + '" ' +
                            'size="20"/>' +
                            '<label class="ms-3">X1<input class="form-control-sm" type="text" id="x1' + roi_name + '" size="2"/></label> ' +
                            '<label>Y1<input class="form-control-sm" type="text" id="y1' + roi_name + '" size="2"/></label>' +
                            '<label>X2<input class="form-control-sm" type="text" id="x2' + roi_name + '" size="2"/></label>' +
                            '<label>Y2<input class="form-control-sm" type="text" id="y2' + roi_name + '" size="2"/></label>' +
                            '<label>Coord<input class="form-control-sm" type="text" id="w' + roi_name + '" name="ocr" size="30"/></label>' +
                            '<a href="#" class="remove_roi bi bi-trash text-danger m-2"></a>' +
                            '</div>' +
                            '</div>'); //add input box
                        initJcrop()

                        function initJcrop() {

                            $('#roi_img').Jcrop({

                                onRelease: function (coords) {
                                    $('#x1' + roi_name).val(Math.round(coords.x * imgscale));
                                    $('#y1' + roi_name).val(Math.round(coords.y * imgscale));
                                    $('#x2' + roi_name).val(Math.round(coords.x2 * imgscale));
                                    $('#y2' + roi_name).val(Math.round(coords.y2 * imgscale));
                                    $('#w' + roi_name).val('[(' + Math.round(coords.x* imgscale) + ',' + Math.round(coords.y* imgscale) + ')' + ',' + '(' + Math.round(coords.x2* imgscale) + ',' + Math.round(coords.y2* imgscale) + ') , "text" , "' + $('#' + roi_name).val() + '"]');
                                },
                                onSelect: function (coords) {
                                    $('#x1' + roi_name).val(Math.round(coords.x * imgscale));
                                    $('#y1' + roi_name).val(Math.round(coords.y * imgscale));
                                    $('#x2' + roi_name).val(Math.round(coords.x2 * imgscale));
                                    $('#y2' + roi_name).val(Math.round(coords.y2 * imgscale));
                                    $('#w' + roi_name).val('[(' + Math.round(coords.x* imgscale) + ',' + Math.round(coords.y* imgscale) + ')' + ',' + '(' + Math.round(coords.x2* imgscale) + ',' + Math.round(coords.y2* imgscale) + ') , "text" , "' + $('#' + roi_name).val() + '"]');
                                },
                            }, function () {
                                jcrop_api = this;
                            });
                        }

                        $('#roi_1').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_1').val(), $('#y1roi_1').val(), $('#x2roi_1').val(), $('#y2roi_1').val()]);
                            jcrop_api.release();
                        });
                        $('#roi_2').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_2').val(), $('#y1roi_2').val(), $('#x2roi_2').val(), $('#y2roi_2').val()]);
                            jcrop_api.release();
                        });
                        $('#roi_3').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_3').val(), $('#y1roi_3').val(), $('#x2roi_3').val(), $('#y2roi_3').val()]);
                            jcrop_api.release();
                        });
                        $('#roi_4').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_4').val(), $('#y1roi_4').val(), $('#x2roi_4').val(), $('#y2roi_4').val()]);
                            jcrop_api.release();
                        });
                        $('#roi_5').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_5').val(), $('#y1roi_5').val(), $('#x2roi_5').val(), $('#y2roi_5').val()]);
                            jcrop_api.release()
                        });
                        $('#roi_6').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_6').val(), $('#y1roi_6').val(), $('#x2roi_6').val(), $('#y2roi_6').val()]);
                            jcrop_api.release()
                        });
                        $('#roi_7').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_7').val(), $('#y1roi_7').val(), $('#x2roi_7').val(), $('#y2roi_7').val()]);
                            jcrop_api.release()
                        });
                        $('#roi_8').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_8').val(), $('#y1roi_8').val(), $('#x2roi_8').val(), $('#y2roi_8').val()]);
                            jcrop_api.release()
                        });
                        $('#roi_9').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_9').val(), $('#y1roi_9').val(), $('#x2roi_9').val(), $('#y2roi_9').val()]);
                            jcrop_api.release()
                        });
                        $('#roi_10').click(function () {
                            {#jcrop_api.destroy()#}
                            jcrop_api.animateTo([$('#x1roi_10').val(), $('#y1roi_10').val(), $('#x2roi_10').val(), $('#y2roi_10').val()]);
                            jcrop_api.release()
                        });
                    } else {
                        alert("Max roi reached")
                    }
                } else {
                    alert("add roi name")
                }
            });

            $(wrapper).on("click", ".remove_roi", function (e) { //user click on remove text
                e.preventDefault();
                $(this).parent('div').remove();
                rx--;
            })
        });

    </script>
{% endblock %}